<template>
    <div class="pa-4 my-4 main-card rounded-t-xl rounded-b-xl">
        <v-card image="https://i.ibb.co/swBHR6f/workshop-login-bg1.png" height="540" variant="text">
            <v-card-title class="text-h6 font-weight-black" style="color: #00695C;">JC.JOB</v-card-title>
            <v-row class="d-flex flex-wrap-reverse rounded-t-xl rounded-b-xl">
                <!-- col-1 bank card -->
                <v-col>
                    <v-card class="mx-auto" max-width="500" min-width="300" variant="text">

                    </v-card>
                </v-col>

                <!-- col-2 login form -->
                <v-col>
                    <v-card class="pa-4 mx-auto glass-background" width="300" height="400" variant="text">
                        <v-card-text class="ml-n4 text-h2 text-start font-weight-black">Login
                        </v-card-text>

                        <v-card-text class="ml-n4 mt-n4 text-body-2 text-start font-weight-thin">Login JC.JOB
                        </v-card-text>

                        <v-form v-model="form" @submit.prevent="login">

                            <v-text-field v-model="email" :readonly="loading"  :rules="[rules.email]" class="mb-2" clearable
                                label="Email" placeholder="Enter your email or user name" variant="underlined">
                            </v-text-field>

                            <v-text-field v-model="password" :readonly="loading" :rules="[rules.password, rules.length(6)]"
                                counter="6" :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'"
                                :type="visible ? 'text' : 'password'" density="compact" label="Password"
                                placeholder="Enter your password" variant="underlined"
                                @click:append-inner="visible = !visible">
                            </v-text-field>

                            <div v-if="failMessage" style="color: red;">{{ failMessage }}</div>
                            <div v-if="successMessage" style="color: green;">{{ successMessage }}</div>
                            <div class="text-subtitle-1 text-medium-emphasis d-flex align-center justify-space-between">

                                <a class="text-caption text-decoration-none" style="color: #2979FF;" href="#"
                                    rel="noopener noreferrer" target="_blank">
                                    Forgot password?</a>
                            </div>
                            <br>
                            <v-btn :disabled="!form" :loading="loading" block
                                style="color: #ffffff; background-color: #00695C;" size="large" type="submit"
                                variant="elevated">
                                LOGIN
                            </v-btn>
                            <v-card-text class="text-center">Don't have account?
                                <a class=" text-decoration-none" style="color: #2979FF;" href="#" rel="noopener noreferrer"
                                    target="_blank">
                                    Sign up
                                </a>
                            </v-card-text>
                        </v-form>
                    </v-card>
                </v-col>
            </v-row>
        </v-card>
    </div>
</template>
  
<script>
const runtimeConfig = useRuntimeConfig();
const apiUrl = runtimeConfig.public.URL_Auth;


definePageMeta({
    middleware: "auth-khan"
    
  })
export default {
    data: () => ({
        form: false,
        visible: false,
        email: null,
        password: null,
        loading: false,
        failMessage: null,
        successMessage: null,
        // input rules email
        rules: {
            email: v => {
        const emailRegex = /@/;
        const dotRegex = /\./;
        const isValidEmail = emailRegex.test(v || '');
        const isValidDot = dotRegex.test(v || '');
        
        if (!isValidEmail && !isValidDot) {
          return 'Please enter a valid email missing @ and domain name (.com)';
        } else if (!isValidEmail) {
          return 'Email address must contain @';
        } else if (!isValidDot) {
          return 'Email address must contain domain name (.com)';
        }
        
        return true;
      },
       // input rules password
        length: len => v => (v || '').length >= len || `Invalid character length, required ${len}`,
        // password: v => !!(v || '').match(/^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*(_|[^\w])).+$/) ||
        //   'Password must contain an upper case letter, a numeric character, and a special character',
        required: v => !!v || 'This field is required',
      },
    }),

    methods: {
       
        // methods login
        async login() {
            const LoginData = {
                username: this.email,
                password: this.password,
                expiresIn: 60000
            };

            try {
                this.loading = true;
                const response = await fetch(`${apiUrl}/api/login`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify(LoginData),
                });
                // Log error request when login fail
                if (!response.ok) {
                    this.failMessage = 'Invalid username or password';
                    const errorData = await response.json();
                    if (response.status === 400) {
                        console.error('Error:', errorData.message);
                    } else if (response.status === 401) {
                        console.error('Error:', errorData.message);
                    }
                    throw new Error('Network response was not ok');
                }

                const data = await response.json();
                console.log('Login success', data);
                // set username and accessToken in local storage
                localStorage.setItem('username', data.user.username);
                localStorage.setItem('accessToken', data.accessToken);
                //go to My profile page when login successful
                setTimeout(() => {
                    this.successMessage = 'Login success';
                    this.loading = false;   
                    this.$router.push('/Khanjana/Khanjana');
                }, 2000);
            } catch (error) {
                console.error('There was an error!', error);
                this.loading = false;
                //alert('Login failed. Invalid username or password.');
            }
        },
    },
}
</script>
  
<style scoped>
.main-card {
    border: 10px solid black;
    border-color: #00695C;
    background-color: white;
}

.glass-background {
    background: rgba(245, 245, 245, 0.3);
    backdrop-filter: blur(5px);
}
</style>
  